#include "json.hpp"

String Myjson::create_json_string(volatile DataStruct *data_struct, size_t nr_dataobjects, time_t runtime_sec)
{
    static unsigned long last_send_ms = 0; 
    unsigned int _sections = nr_dataobjects;                 //number of different values
    const unsigned int _sec_objects = NR_JSON_SECTION_OBJECTS;     //number of objects per value
    const unsigned int _obj_members = 5;                           //number of members per object
    String json_str = "";

    int _capacity = JSON_ARRAY_SIZE(_sections) + _sec_objects*JSON_OBJECT_SIZE(_obj_members);
    DynamicJsonDocument _doc(_capacity + 100);
    _doc["runtime_s"] = runtime_sec;
    JsonObject _doc_object[_sections];
    for(unsigned int section_nr = 0; section_nr < _sections; section_nr++)
    {   
        _doc_object[section_nr] = _doc.createNestedObject(data_struct[section_nr].name);
        _doc_object[section_nr]["ticks"] = data_struct[section_nr].ticks;        
        _doc_object[section_nr]["value"] = data_struct[section_nr].value;
        _doc_object[section_nr]["unit"] = data_struct[section_nr].unit;
        _doc_object[section_nr]["timestamp"] = data_struct[section_nr].timestamp;
    }

    int nr_bytes = serializeJson(_doc, json_str);

    return(json_str);

}